local movieObjectTable = {}

function drawMovieObject(obj)
	if movieObjectTable[obj.id] ~= nil then
		local x,y = graphics.getScrollPosition()
		local movie = movieObjectTable[obj.id][1]
		local scaleX, scaleY, tX, tY = graphics.getMatrix1Properties()
		local w,h = movie.width, movie.height
		x = (-x * obj.ScrollFactorX * 0.01 + obj.Position.x)*scaleX + tX
		y = (-y * obj.ScrollFactorY * 0.01 + obj.Position.y)*scaleY + tY
		local b = game.CurrentScene.Brightness*2.551
		movie.color = {math.floor(b),math.floor(b),math.floor(b),math.floor(obj.Visibility*2.551)}
		movie:draw(x,y,w*scaleX*movieObjectTable[obj.id][2],h*scaleY*movieObjectTable[obj.id][3])
	end
	return false -- if true it wont draw internally
end

local curScene = game.CurrentScene

function movieUpdate()
	if curScene ~= game.CurrentScene then
		curScene = game.CurrentScene
		for k,v in pairs(movieObjectTable) do
			if getObject("("..eObjects..","..k..")").parent ~= curScene then
				v[1]:finish()
				movieObjectTable[k] = nil
			end
		end
	end
end
registerEventHandler("mainLoop","movieUpdate")

function addMovie(object, file, loop, blend)
  if not object:isEmpty() then
  	local m = graphics.movieOpen(file)
	  m.blend = blend
	  m.loop = loop
	  movieObjectTable[object.id] = {m,1,1}
    graphics.registerRenderHook(object, "drawMovieObject")
  end
end

function addMovieScaled(object, file, scaleX, scaleY, loop, blend)
  if not object:isEmpty() then
  	local m = graphics.movieOpen(file)
	  m.blend = blend
	  m.loop = loop
	  movieObjectTable[object.id] = {m,scaleX,scaleY}
      graphics.registerRenderHook(object, "drawMovieObject")
  end
end

registerActionPart("PLAY_VIDEO_ON_OBJECT",function(activeAction, actionPart)
	addMovieScaled(actionPart.Link, actionPart.Path, actionPart.AltInt2 / 100, actionPart.AltInt2 / 100, actionPart.Int == 1, actionPart.AltInt)
	return false -- end of action
end)